searchData={"items":[{"type":"module","doc":"PhoenixGenApi is a library to help you to generate API for Phoenix.\n\nGo to modules to see more details.","title":"PhoenixGenApi","ref":"PhoenixGenApi.html"},{"type":"function","doc":"Stop stream call from channel process.\nIn this case the stream call will be stopped without notification to data generator process.\nParameter `request_id` is the request id of that stream when the stream is created.","title":"PhoenixGenApi.stop_stream/1","ref":"PhoenixGenApi.html#stop_stream/1"},{"type":"module","doc":"This module provides a cache for `Executor` can get `%FunConfig{}` config by `request_type`.\n\nUse `:ets` to store config in memory.\n\nApplication can add, update, delete, get config from this cache.\n\n`PhoenixGenApi.ConfigPuller` will pull config from nodes and update to this cache.","title":"PhoenixGenApi.ConfigCache","ref":"PhoenixGenApi.ConfigCache.html"},{"type":"function","doc":"Add a new config to cache.","title":"PhoenixGenApi.ConfigCache.add/1","ref":"PhoenixGenApi.ConfigCache.html#add/1"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"PhoenixGenApi.ConfigCache.child_spec/1","ref":"PhoenixGenApi.ConfigCache.html#child_spec/1"},{"type":"function","doc":"Delete a config from cache.","title":"PhoenixGenApi.ConfigCache.delete/1","ref":"PhoenixGenApi.ConfigCache.html#delete/1"},{"type":"function","doc":"Get a config from cache.","title":"PhoenixGenApi.ConfigCache.get/1","ref":"PhoenixGenApi.ConfigCache.html#get/1"},{"type":"function","doc":"Get all keys in cache.","title":"PhoenixGenApi.ConfigCache.get_all_keys/0","ref":"PhoenixGenApi.ConfigCache.html#get_all_keys/0"},{"type":"function","doc":"Start the cache.","title":"PhoenixGenApi.ConfigCache.start_link/1","ref":"PhoenixGenApi.ConfigCache.html#start_link/1"},{"type":"function","doc":"Update a config in cache.","title":"PhoenixGenApi.ConfigCache.update/1","ref":"PhoenixGenApi.ConfigCache.html#update/1"},{"type":"module","doc":"This is automation module for pull `%FunConfig{}` from nodes and update to cache.\n\nConfigs for Pullter can be set in config file like:\n\n```Elixir\nconfig :phoenix_gen_api, :gen_api,\npull_timeout: 3_000,\npull_interval: 60_000\n```\n\ndefault timeout is 5s, refresh time is 30s.","title":"PhoenixGenApi.ConfigPuller","ref":"PhoenixGenApi.ConfigPuller.html"},{"type":"function","doc":"Add nodes to pull config from.\nNodes is a list of %ServiceConfig{}.","title":"PhoenixGenApi.ConfigPuller.add/1","ref":"PhoenixGenApi.ConfigPuller.html#add/1"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"PhoenixGenApi.ConfigPuller.child_spec/1","ref":"PhoenixGenApi.ConfigPuller.html#child_spec/1"},{"type":"function","doc":"Delete services from pull config from.\nNodes is a list of %ServiceConfig{}.","title":"PhoenixGenApi.ConfigPuller.delete/1","ref":"PhoenixGenApi.ConfigPuller.html#delete/1"},{"type":"function","doc":"Get api list from node.","title":"PhoenixGenApi.ConfigPuller.get_api_list/1","ref":"PhoenixGenApi.ConfigPuller.html#get_api_list/1"},{"type":"function","doc":"Get nodes that will be pulled config from.","title":"PhoenixGenApi.ConfigPuller.get_services/0","ref":"PhoenixGenApi.ConfigPuller.html#get_services/0"},{"type":"function","doc":"Force pull config from nodes.","title":"PhoenixGenApi.ConfigPuller.pull/0","ref":"PhoenixGenApi.ConfigPuller.html#pull/0"},{"type":"function","doc":"","title":"PhoenixGenApi.ConfigPuller.start_link/1","ref":"PhoenixGenApi.ConfigPuller.html#start_link/1"},{"type":"module","doc":"This module is the core of PhoenixGenApi.\nIt will execute the request from client and return the response.\nResponse can be sync, async, or stream.\n\nThis module will handle the request, check permission, convert args, and call the remote node.\n\nIf the function is local, it will call the function directly.\nIf the function is remote, it will call the function via RPC.\n\nIf the function is sync, it will call the function and return the response immediately.\nIf the function is async, it will spawn a new process to call the function and return the response immediately.\nIf the function is stream, it will start a new process to handle the stream and return the response immediately.\n\nfor case async and stream, the response will be sent to the client later Channel process will receive the response and send it to the client.","title":"PhoenixGenApi.Executor","ref":"PhoenixGenApi.Executor.html"},{"type":"function","doc":"Async call a request support for async/none response.","title":"PhoenixGenApi.Executor.async_call/2","ref":"PhoenixGenApi.Executor.html#async_call/2"},{"type":"function","doc":"","title":"PhoenixGenApi.Executor.call/2","ref":"PhoenixGenApi.Executor.html#call/2"},{"type":"function","doc":"Execute a request.","title":"PhoenixGenApi.Executor.execute!/1","ref":"PhoenixGenApi.Executor.html#execute!/1"},{"type":"function","doc":"Execute a request from params.\nParams is a map from playload in Phoenix Channel event (handle_in).\nFunction will raise an error if something wrong.\n\nParams:\n  - request_id: String.t()\n  - request_type: String.t()\n  - user_id: String.t()\n  - device_id: String.t()\n  - args: map()","title":"PhoenixGenApi.Executor.execute_params!/1","ref":"PhoenixGenApi.Executor.html#execute_params!/1"},{"type":"function","doc":"Stream call a request support for stream response.","title":"PhoenixGenApi.Executor.stream_call/2","ref":"PhoenixGenApi.Executor.html#stream_call/2"},{"type":"module","doc":"","title":"PhoenixGenApi.JasonImplHelper","ref":"PhoenixGenApi.JasonImplHelper.html"},{"type":"macro","doc":"Macro to generate simple implementation of protocol.\nSupport for easy to use with Jason.Encoder.\n\nUtility macro to generate implementation for Jason.Encoder.\n\nThe target struct must have `encode!` function in module.\n\nUsage:\n\n```Elixir\nuse PhoenixGenApi.NestruImplHelper, impl: [AModule1, AModule2, ...]\n```\n\nUsing macro without option in `use` keyword.\nTarget module must have `encode!` function\nGenerate implementation for Jason.Encoder like this:\n\n```Elixir\ngen_impl AModule\n```","title":"PhoenixGenApi.JasonImplHelper.__using__/1","ref":"PhoenixGenApi.JasonImplHelper.html#__using__/1"},{"type":"macro","doc":"","title":"PhoenixGenApi.JasonImplHelper.gen_impl/1","ref":"PhoenixGenApi.JasonImplHelper.html#gen_impl/1"},{"type":"module","doc":"Module helps to handle stream call.","title":"PhoenixGenApi.StreamCall","ref":"PhoenixGenApi.StreamCall.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"PhoenixGenApi.StreamCall.child_spec/1","ref":"PhoenixGenApi.StreamCall.html#child_spec/1"},{"type":"function","doc":"","title":"PhoenixGenApi.StreamCall.send_data/2","ref":"PhoenixGenApi.StreamCall.html#send_data/2"},{"type":"function","doc":"","title":"PhoenixGenApi.StreamCall.send_last_data/2","ref":"PhoenixGenApi.StreamCall.html#send_last_data/2"},{"type":"function","doc":"","title":"PhoenixGenApi.StreamCall.start_link/1","ref":"PhoenixGenApi.StreamCall.html#start_link/1"},{"type":"function","doc":"","title":"PhoenixGenApi.StreamCall.stop/1","ref":"PhoenixGenApi.StreamCall.html#stop/1"},{"type":"module","doc":"For declare a general config for a function.","title":"PhoenixGenApi.Structs.FunConfig","ref":"PhoenixGenApi.Structs.FunConfig.html"},{"type":"module","doc":"Based on function config, the request will be forwarded to the target service.\nParams will be validated & converted to the correct types before forwarding.\nThe response will be handled based on the response type.\n\nFor basic check permission, it will check if the user_id of the request is the same as the user_id in the argument (indicated by `check_permission`, ex: check_permission: {:arg, arg_name}).\n\nFor advanced permission check, please pass the request_info to the target function for checking.","title":"Summary - PhoenixGenApi.Structs.FunConfig","ref":"PhoenixGenApi.Structs.FunConfig.html#module-summary"},{"type":"module","doc":"Below is an example of a function config:\n\n```Elixir\n%FunConfig{\n  request_type: \"get_user\",\n  service: :user,\n  nodes: [\"user1\", \"user2\"],\n  choose_node_mode: :random,\n  timeout: 1000,\n  mfa: {User, :get_user, []},\n  arg_types: %{\n    \"user_id\" => :string,\n    \"device_id\" => :string,\n  },\n  arg_orders: [\"user_id\", \"device_id\"],\n  response_type: :async,\n  check_permission: false,\n  request_info: true,\n}\n```\n\nExplain:\n\n- `request_type`: the unique identifier for the type of request & response.\n  This is unqiue name in system for cliet can call right function.\n\n- `service`: the service that will handle the request.\n\n- `nodes`: the nodes that will handle the request. You can choose local node by set to `:local`.\n  Currently, all nodes must have the same config.\n\n- `choose_node_mode`: the way to chose node, support: `:random`, `:hash`, `:round_robin`.\n\n- `timeout`: the timeout for the request.\n\n- `mfa`: the module, function, and arguments that will be called to handle the request.\n\n- `arg_types`: the types of the arguments that will be passed to the function. For validation & converting.\n\n- `arg_orders`: the order of the arguments that will be passed to the function.\n\n- `response_type`: indicates if the request has a response. Type of response: `:sync`, `:async`, `:stream`, `:none`.\n\n- `check_permission`: check permission, false or `{:arg, arg_name}`.\n\n- `request_info`: indicates if need request info, info will be added to the request in the last argument.\n  `%{request_id: request_id, user_id: user_id, device_id: device_id}`.\n  `user_id` is the user_id of the user who made the request.","title":"Example - PhoenixGenApi.Structs.FunConfig","ref":"PhoenixGenApi.Structs.FunConfig.html#module-example"},{"type":"function","doc":"Check permission for request from client.","title":"PhoenixGenApi.Structs.FunConfig.check_permission/2","ref":"PhoenixGenApi.Structs.FunConfig.html#check_permission/2"},{"type":"function","doc":"","title":"PhoenixGenApi.Structs.FunConfig.check_permission!/2","ref":"PhoenixGenApi.Structs.FunConfig.html#check_permission!/2"},{"type":"function","doc":"Validate & Convert request arguments to the correct types.","title":"PhoenixGenApi.Structs.FunConfig.convert_args!/2","ref":"PhoenixGenApi.Structs.FunConfig.html#convert_args!/2"},{"type":"function","doc":"Select target based on config.","title":"PhoenixGenApi.Structs.FunConfig.get_node/2","ref":"PhoenixGenApi.Structs.FunConfig.html#get_node/2"},{"type":"function","doc":"Check if the service is local (run on the same node).","title":"PhoenixGenApi.Structs.FunConfig.is_local_service?/1","ref":"PhoenixGenApi.Structs.FunConfig.html#is_local_service?/1"},{"type":"type","doc":"","title":"PhoenixGenApi.Structs.FunConfig.t/0","ref":"PhoenixGenApi.Structs.FunConfig.html#t:t/0"},{"type":"function","doc":"Validate request arguments.","title":"PhoenixGenApi.Structs.FunConfig.validate_args!/2","ref":"PhoenixGenApi.Structs.FunConfig.html#validate_args!/2"},{"type":"module","doc":"Request struct for internal using, convert data map from websocket api.\n\nData from websocket api has payload like this:\n\n```Elixir\n%{\n  \"request_id\" => \"request_id\",\n  \"request_type\" => \"request_type\",\n  \"user_id\" => \"user_id\",\n  \"device_id\" => \"device_id\",\n  \"args\" => %{}\n}\n```\n\nWe need to convert it to struct for internal using.\n\nLike this:\n\n```Elixir\n%PhoenixGenApi.Structs.Request{\n  request_id: \"request_id\",\n  request_type: \"request_type\",\n  user_id: \"user_id\",\n  device_id: \"device_id\",\n  args: %{}\n}\n```\n\nExplain:\n- user_id: string, user's id in system.\n  User's id in system. It need to check permission.\n\n- device_id: string, device id of current connection.\n  Device id of current connection.\n\n- request_type: string, request type.\n  Request type. Using for identify function to call in system.\n\n- request_id: string, unique id for request. Make by client.\n  Unique id for request. Make by client. Using for identify response.\n\n- args: map, field -> value, arguments for request.\n  Arguments for request. Using for call function in system.","title":"PhoenixGenApi.Structs.Request","ref":"PhoenixGenApi.Structs.Request.html"},{"type":"function","doc":"Create Request from params for convert data map from websocket api.","title":"PhoenixGenApi.Structs.Request.decode!/1","ref":"PhoenixGenApi.Structs.Request.html#decode!/1"},{"type":"type","doc":"Request struct for internal using, convert data map from websocket api.","title":"PhoenixGenApi.Structs.Request.t/0","ref":"PhoenixGenApi.Structs.Request.html#t:t/0"},{"type":"module","doc":"Response struct for internal using, convert data map from websocket api.\n\nData after pass throught websocket api client will received a event has payload like this:\n\n```Elixir\n%{\n  \"request_id\" => \"request_id\",\n  \"result\" => data or null,\n  \"success\" => boolean,\n  \"error\" => string if has error,\n  \"async\" => boolean,\n  \"has_more\" => boolean\n}\n```\n\nInternal struct like:\n\n```Elixir\n%PhoenixGenApi.Structs.Response{\n  request_id: \"request_id\",\n  result: data or nil,\n  success: boolean,\n  error: string if has error,\n  async: boolean,\n  has_more: boolean\n}\n```\n\nExplain:\n- request_id: string, unique id from request. Make by client.\n  send back to client for identify request.\n\n- result: map, field -> value, result for request. If is async/stream\n  this field is null for first time. Client must wait for next response.\n\n- success: boolean, success or not. for case async/stream, server is processing\n\n- error: string, error message.\n\n- async: boolean, is async response or not.\n\n- has_more: boolean, indicates has more data for stream request.\n\nFor Phoenix can convert result to json and send to client,\nwe need to make sure data can be convert to json.\nOr we need implement a Jason.Encoder for our struct.\n\nIf Struct has function `encode!`, can use macro `use PhoenixGenApi.JasonImplHelpe` to generate Jason.Encoder implementation.","title":"PhoenixGenApi.Structs.Response","ref":"PhoenixGenApi.Structs.Response.html"},{"type":"function","doc":"","title":"PhoenixGenApi.Structs.Response.async_response/1","ref":"PhoenixGenApi.Structs.Response.html#async_response/1"},{"type":"function","doc":"Create Request from params for convert data map from websocket api.","title":"PhoenixGenApi.Structs.Response.encode!/1","ref":"PhoenixGenApi.Structs.Response.html#encode!/1"},{"type":"function","doc":"","title":"PhoenixGenApi.Structs.Response.error_response/2","ref":"PhoenixGenApi.Structs.Response.html#error_response/2"},{"type":"function","doc":"","title":"PhoenixGenApi.Structs.Response.is_error?/1","ref":"PhoenixGenApi.Structs.Response.html#is_error?/1"},{"type":"function","doc":"","title":"PhoenixGenApi.Structs.Response.stream_response/3","ref":"PhoenixGenApi.Structs.Response.html#stream_response/3"},{"type":"function","doc":"","title":"PhoenixGenApi.Structs.Response.success_response/2","ref":"PhoenixGenApi.Structs.Response.html#success_response/2"},{"type":"function","doc":"","title":"PhoenixGenApi.Structs.Response.sync_response/2","ref":"PhoenixGenApi.Structs.Response.html#sync_response/2"},{"type":"type","doc":"Response struct for internal using.","title":"PhoenixGenApi.Structs.Response.t/0","ref":"PhoenixGenApi.Structs.Response.html#t:t/0"},{"type":"module","doc":"Node config struct.","title":"PhoenixGenApi.Structs.ServiceConfig","ref":"PhoenixGenApi.Structs.ServiceConfig.html"},{"type":"function","doc":"","title":"PhoenixGenApi.Structs.ServiceConfig.from_map/1","ref":"PhoenixGenApi.Structs.ServiceConfig.html#from_map/1"},{"type":"type","doc":"service config struct.","title":"PhoenixGenApi.Structs.ServiceConfig.t/0","ref":"PhoenixGenApi.Structs.ServiceConfig.html#t:t/0"},{"type":"module","doc":"Support for send data to stream.","title":"PhoenixGenApi.Structs.StreamHelper","ref":"PhoenixGenApi.Structs.StreamHelper.html"},{"type":"function","doc":"Wrap complete & send to stream.","title":"PhoenixGenApi.Structs.StreamHelper.send_complete/1","ref":"PhoenixGenApi.Structs.StreamHelper.html#send_complete/1"},{"type":"function","doc":"Wrap error & send to stream.","title":"PhoenixGenApi.Structs.StreamHelper.send_error/2","ref":"PhoenixGenApi.Structs.StreamHelper.html#send_error/2"},{"type":"function","doc":"Wrap last result & send to stream.","title":"PhoenixGenApi.Structs.StreamHelper.send_last_result/2","ref":"PhoenixGenApi.Structs.StreamHelper.html#send_last_result/2"},{"type":"function","doc":"Wrap result & send to stream.","title":"PhoenixGenApi.Structs.StreamHelper.send_result/2","ref":"PhoenixGenApi.Structs.StreamHelper.html#send_result/2"},{"type":"type","doc":"Stream helper struct.","title":"PhoenixGenApi.Structs.StreamHelper.t/0","ref":"PhoenixGenApi.Structs.StreamHelper.html#t:t/0"},{"type":"extras","doc":"[![Docs](https://img.shields.io/badge/api-docs-green.svg?style=flat)](https://hexdocs.pm/phoenix_gen_api)\n[![Hex.pm](https://img.shields.io/hexpm/v/phoenix_gen_api.svg?style=flat&color=blue)](https://hex.pm/packages/phoenix_gen_api)\n\n# PhoenixGenApi\n\nThe library helps quickly develop APIs for client, the library is based on Phoenix Channel.\nDevelopers can add or update APIs in runtime from other nodes in the cluster without restarting or reconfiguring the Phoenix app.\nIn this case, the Phoenix app will take on the role of an API gateway.\n\nThe library can use with [EasyRpc](https://hex.pm/packages/easy_rpc) and [ClusterHelper](https://hex.pm/packages/cluster_helper) for fast and easy to develop a dynamic Elixir cluster.","title":"Readme","ref":"readme.html"},{"type":"extras","doc":"After received an event from client(in handle_in callback of Phoenix Channel), the event will be passed to PhoenixGenApi to find target API & target node to execute then get result for response to client.\n\nFor service nodes (target node), the libray support some basic strategy for selecting node (:choose_node_mode) like: :random, :hash, :round_robin(will be added in the future).\n\nSupported :sync, :async, :stream for request/response to client.\n\nSupported basic check type & permission.","title":"Concept - Readme","ref":"readme.html#concept"},{"type":"extras","doc":"The package can be installed\nby adding `phoenix_gen_api` to your list of dependencies in `mix.exs`:\n\n```Elixir\ndef deps do\n  [\n    {:phoenix_gen_api, \"~> 0.0.8\"}\n  ]\nend\n```\n\nNote: You can use [`:libcluster`](https://hex.pm/packages/libcluster) to build a Elixir cluster.","title":"Installation - Readme","ref":"readme.html#installation"},{"type":"extras","doc":"","title":"Usage - Readme","ref":"readme.html#usage"},{"type":"extras","doc":"Add config to your `config.exs` file to mark this is remote node.\n\n```Elixir\nconfig :phoenix_gen_api, :client_mode, true\n```\n\nDeclare a module for support PhoenixGenApi can pull config.\n\nExample:\n\n```Elixir\ndefmodule MyApp.GenApi.Supporter do\n\n  alias PhoenixGenApi.Structs.FunConfig\n\n  @doc \"\"\"\n  Support for remote pull general api config.\n  \"\"\"\n  def get_config() do\n    {:ok, my_fun_configs()}\n  end\n\n  @doc \"\"\"\n  Return list of %FunConfig{}.\n  \"\"\"\n  def my_fun_configs() do\n    [\n      %FunConfig{\n        request_type: \"get_data\",\n        service: :my_service,\n        nodes: [Node.self()],\n        choose_node_mode: :random,\n        timeout: 5_000,\n        mfa: {MyApp.Interface.Api, :get_data, []},\n        arg_types: %{\"id\" => :string},\n        response_type: :async\n      }\n    ]\n  end\nend\n```\n\nNote: You can add directly in runtime in gateway node without using client mode.","title":"Remote Node (optional) - Readme","ref":"readme.html#remote-node-optional"},{"type":"extras","doc":"Add config for Phoenix can pull config from remote nodes(above) like:\n\n```Elixir\n# Config for general api, lib made by team.\nconfig :phoenix_gen_api, :gen_api,\n  service_configs: [\n    # service config for pulling general api config.\n    %{\n      # service type\n      service: :my_service,\n      # nodes of service in cluster, need to connecto to get config\n      nodes: [:\"remote_service@test.local\"], # or using MFA like: {ClusterHelper, get_nodes, [:my_api]}\n      # module to get config\n      module: MyApp.GenApi.Supporter,\n      # function to get config\n      function: :get_config,\n      # args to get config, using for identity or check security.\n      args: [:gateway_1],\n    }\n  ]\n```\n\nIn Phoenix Channel you can add a lit of bit code like:\n\n```Elixir\n@impl true\ndef handle_in(\"phoenix_gen_api\", payload, socket) do\n  result = \n    payload\n    |> Map.put(\"user_id\", socket.assigns.user_id) # avoid security issue.\n    |> PhoenixGenApi.Executor.execute_params()\n\n\n    case result do\n      result = %Response{} ->\n\n      # not a final result for async/stream call.\n      push(socket, \"gen_api_result\", result)\n\n    # request type is :none, no response.\n    {:ok, :no_response} ->\n      :ok\n    end\n\n  {:noreply, socket}\nend\n\n@impl true\ndef handle_info({:push, result}, socket) do\n  push(socket, \"phoenix_gen_api_result\", result)\n\n  {:noreply, socket}\nend\n\ndef handle_info({:async_call, result = %Response{}}, socket) do\n  push(socket, \"phoenix_gen_api_result\", result)\n\n  {:noreply, socket}\nend\n\n# For receiving data from stream.\ndef handle_info({:stream_response, result}, socket) do\n  push(socket, \"gen_api_result\", result)\n\n  {:noreply, socket}\nend\n```\n\nIn this case, if need you can authenticate by using Phoenix framework.\n\nNow you can start your cluster and test!\n\nAfter start Phoenix app, PhoenixGenApi will auto pull config from remote node to serve client.\n\nFor test in Elixir you can use  [`phoenix_client`](https://hex.pm/packages/phoenix_client) to create a connection to Phoenix Channel.\n\nYou can push a event with content like:\n\n```json\n{\n  \"user_id\": \"user_1\",\n  \"device_id\": \"device_1\",\n  \"request_type\": \"get_data\",\n  \"request_id\": \"test_request_1\",\n  \"args\": {\n    \"id\": \"test_data_id\"\n  }\n}\n```\n\nResult like:\n\nIf is async/stream call you will receive a message like this:\n\n```json\n{\n  \"async\": true,\n  \"error\": \"\",\n  \"has_more\": false,\n  \"request_id\": \"test_request_1\",\n  \"result\": null,\n  \"success\": true\n}\n```\n\nAfter that is a another message with result:\n\n```json\n{\n  \"async\": false,\n  \"error\": \"\",\n  \"has_more\": false,\n  \"request_id\": \"test_request_1\",\n  \"result\": [\n    {\n      \"id\": \"14e99227-512a-47b6-b6b1-2d4bc29ca13e\",\n      \"name\": \"Hello World!\"\n    }\n  ]\n}\n```\n\nFor better security you can overwrite user_id in server, using basic check permission or passing request info (user_id, device_id, request_id).","title":"Phoenix Node (Gateway node) - Readme","ref":"readme.html#phoenix-node-gateway-node"},{"type":"extras","doc":"We will add a full example in the future.","title":"Full Example - Readme","ref":"readme.html#full-example"},{"type":"extras","doc":"- Add pool processes for save/limit resource.\n- Sticky node.\n- Rate limiter.","title":"Planned Features - Readme","ref":"readme.html#planned-features"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}